#include <stdio.h>
#include <linux/isdn.h>
#include <iostream.h>
#include <qstring.h>
#include <qframe.h>
#include <qlabel.h>

#include <led.h>
#include <amt.moc>

/***************************************************************
 * Draw Label, LED and Frame for Nst
 ***************************************************************/
Amt::Amt(QWidget* _parent=0, const char* _name=0, int index=0) 
	: QFrame(_parent, _name)
{
	int h_size = 41;
	int v_size = 20;

	resize(h_size, v_size);

	int h_pos = 0;

	__index = index;

	__lab = new QLabel(this);
	__lab->resize(h_size,12);
	__lab->setAlignment(AlignHCenter);
	__lab->move(h_pos, 0);
	__lab->setText(_name);

	__led1 = new led(this);
	__led1->resize(20,7);
	__led1->move(h_pos, 13);

	__led2 = new led(this);
	__led2->resize(20,7);
	__led2->move(h_pos+21, 13);
}

/***************************************************************
 * Free Space
 ***************************************************************/
Amt::~Amt()
{
	delete __lab;
	delete __led1;
	delete __led2;
}


/***************************************************************
 * Set LEDs indicator
 ***************************************************************/
void Amt::setStatus(const vector<BYTE>& status, int offset)
{
	int byt = 2 * offset + __index;

	int offh = status[byt];

	if (offh == 1) {
		__led1->offhook();
		__led2->idle();
	}
	else if (offh == 2) {
		__led1->offhook();
		__led2->offhook();
	}
	else {
		__led1->idle();
		__led2->idle();
	}
}

void Amt::setText(QString text)
{
	__lab->setText(text);
}

void Amt::setText(char *text)
{
	__lab->setText(text);
}
