#include <stdio.h>
#include <linux/isdn.h>
#include <iostream.h>
#include <qstring.h>
#include <qframe.h>
#include <qlabel.h>
#include <qevent.h>
#include <qdragobject.h> 

#include <TlnInfo.h>
#include <led.h>
#include <nst.moc>

/***************************************************************
 * Draw Label, LED and Frame for Nst
 ***************************************************************/
Nst::Nst(QWidget* _parent=0, const char* _name=0, TlnInfo* _info=0L) 
	: QFrame(_parent, _name)
{
	fflush(stdout);
	int h_size = 25;

	pressed = -1;
	int h_pos = 0;
	int s_width = h_size;
	int l_heigth = 7;

	__info = _info;

	__ulab = new QLabel(this);
	__ulab->resize(s_width,12);
	__ulab->setAlignment(AlignHCenter);
	__ulab->move(h_pos, 0 /*__lab->height() + __led->height() + 4*/);
	
	__lab = new QLabel(this);
	__lab->resize(s_width,12);
	__lab->setAlignment(AlignHCenter);
	__lab->move(h_pos,  __lab->height() + 2);
	__lab->setText(__info->Nummer());
	
	QFont f = __lab->font();
	f.setBold(true);
	__lab->setFont(f);

	__led = new led(this);
	__led->resize(__lab->width(),l_heigth);
	__led->move(h_pos, __lab->height() + __ulab->height() + 4);

	char *typ = 0L;

	switch (__info->Untertyp()){
		case 0x00:	typ = "Tel"; break;
		case 0x01:	typ = "Fax"; break;
		case 0x02:	typ = "AB"; break;
		case 0x03:	typ = "Mod"; break;
		case 0x04:	typ = "Mul"; break;
		case 0x05:	typ = "PC"; break;
		default:
		if (__info->Typ() == 0x04) 
			typ = "TFE";
		else
			typ = "---";
	}
	__ulab->setText(typ);

	resize(h_size, __lab->height() + __led->height() +  __lab->height() + 6);
}

/***************************************************************
 * Free Space
 ***************************************************************/
Nst::~Nst()
{
	delete __lab;
	delete __led;
}


/***************************************************************
 * Set LEDs indicator
 ***************************************************************/
void Nst::setStatus(const vector<BYTE> &status, int offset)
{
	int byt = __info->BitPos() / 8;
	int bit = __info->BitPos() % 8;

	int offh = (status[byt] >> bit) & 0x01;
	int ring = (status[byt + offset] >> bit) & 0x01;

	if (offh)
		__led->offhook();
	else if(ring)
		__led->ringing();
	else
		__led->idle();
}

void Nst::setText(QString text)
{
	__lab->setText(text);
}

void Nst::setText(char *text)
{
	__lab->setText(text);
}

void Nst::mouseReleaseEvent( QMouseEvent * _mouse )
{
	if (_mouse->button() == LeftButton)
		pressed = 0;
	press_y = _mouse->y();
	press_x = _mouse->x();
}

void Nst::mousePressEvent( QMouseEvent * _mouse )
{
	if (_mouse->button() == LeftButton)
		pressed = 1;
	press_y = _mouse->y();
	press_x = _mouse->x();
}

void Nst::mouseMoveEvent( QMouseEvent * _mouse )
{
	if ( !pressed || pressed == -1)
		return;

		QTextDrag *drg = new QTextDrag("test",this);
		drg->drag();
}
