// Anlegen der Datenbank
create database maks_db;

// Verbinden mit der Datenbank
\connect maks_db

// Tabelle fuer Anrufer anlegen ...
create table caller ( 
	c_number		varchar(25)	,
	c_name		varchar(40)	,
	c_short		int
	);

// und Daten eintragen
insert into caller values ('06356989333','Die Benndorfs',290);

// Tabelle fuer Nebenstellen anlegen ...
create table xtend ( 
	x_number		int		,
	x_name		varchar(40)	
	);

// und Daten eintragen
// PASSEN SIE DIESE DATEN BITTE AN IHRE KONFIGURATION AN!
insert into xtend values (11,'Chris');
insert into xtend values (12,'Anja');
insert into xtend values (50,'Modem/Fax');
insert into xtend values (14,'Wohnzimmer');
insert into xtend values (15,'Kueche');
insert into xtend values (16,'Schlafzimmer');
insert into xtend values (17,'Bastelzimmer');
insert into xtend values (13,'Esszimmer');
insert into xtend values (20,'Sammelruf');
insert into xtend values (21,'Chris ISDN');
insert into xtend values (22,'Ganzfix');
insert into xtend values (23,'Ganzfix');
insert into xtend values (24,'ISDN-Test');
insert into xtend values (25,'nicht belegt');
insert into xtend values (26,'nicht belegt');
insert into xtend values (27,'nicht belegt');
insert into xtend values (28,'Ganzfix AB2');
insert into xtend values (29,'Ganzfix AB1');

// Tabelle fuer die MSNs anlegen ...
create table port ( 
	m_port		int		,
	m_idx		int		,
	m_msn		int		,
	m_name		varchar(40)	
	);

// und Daten eintragen
// PASSEN SIE DIESE DATEN BITTE AN IHRE KONFIGURATION AN!
insert into port values (1,0,989333,'Benndorf');
insert into port values (1,1,000000,'Lion');
insert into port values (1,2,111111,'Alina');
insert into port values (1,3,222222,'Conni');
insert into port values (1,4,333333,'Gabi');
insert into port values (1,5,444444,'Rike');
insert into port values (1,6,555555,'Timm');
insert into port values (1,7,666666,'Rolf');
insert into port values (1,8,777777,'Chris');
insert into port values (1,9,0,'nicht belegt');

// Tabelle fuer die MSNs anlegen ...
// In diese Tabelle schreibt "Gabi"!
create table calls ( 
	p_number	varchar(26)	,
	p_date		date		,
	p_time		time		,
	p_duration	int		,
	p_costs		float		,
	p_xtend		int		,
	p_group		int		,
	p_port		int		,
	p_msn		int		,
	p_io		int				 
	);

// Gabi wird (bei MIR!) von "root" gestartet und muss somit
// Schreibrecht haben. 
// Rechte fuer SELECT,INSERT,UPDATE an "root" geben.
grant SELECT,INSERT,UPDATE on caller,xtend,calls,port to root;

// Der User "chrisb" soll (bei MIR!) lesen (SELECT) und aendern
// (UPDATE) koennen.
grant SELECT,UPDATE on caller,xtend,calls,port to chrisb;

// Sollen alle anderen auch lesen koennen, muss die naechste Zeile
// aktiviert werden.
// grant SELECT on caller,xtend,calls,port to all;

// und tschuess
\q
