#include <iostream>
#include <string>
#include <NGApp.h>
#include <MsgHandlerNG.h>
#include <Q931.h>

int debug = 1;

void analyzer(ESPMsgHdr *ep) {
	q931Pack p(ep,debug);
}

void fail(MsgHandler* mh) {
	cerr << mh->failReason() << endl;
}

void start(ESPMsgHdr *ep) {
	if (ep->isError()) {
		cerr << "Error packet received!" << endl;
		globalApp->quit(1);
	}
}

int main(int argc, char **argv) {

	NGApp app(argc,argv);

	app.getOpts().addOption("d","\t[-d][-d][-d]... Debuglevel++\n");

	if (!app.checkOpts(argc, argv)) {
		app.getOpts().printUsage(cerr);
		exit(1);
	}

	debug += app.getOpts().isOption('d');

	MsgHandlerNG*	mh = app.createMsgHandler(MsgHandler::PERM_S0MON|MsgHandler::PERM_BMON);

	mh->staMsg.connect(slot(&analyzer));
	mh->failMsg.connect(slot(&fail));		//Kann erst bei spaeteren asyncSend auftreten
	mh->rdyMsg.connect(slot(&start));

	// mh->switchDebug(true);
	mh->esp_conn_req();

	if (app.exec() != 0) {
		// Dies klappt nicht! Kommt _immer_ "NoErr"
		cerr << mh->failReason() << endl;
	}
	
}

