/********************************************************************
 * Dialer.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: Dialer.h,v 1.1 1999/12/30 20:56:45 root Exp root $
 *
 ********************************************************************/

#ifndef __DIALER_H__
#define __DIALER_H__

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef KApplication
#include <kapp.h>
#endif

#ifndef KSocket
#include <ksock.h>
#endif

#ifndef KConfig
#include <kconfig.h>
#endif

#ifndef QDialog
#include <qdialog.h>
#endif

#ifndef QFrame
#include <qframe.h>
#endif

#ifndef QLabel
#include <qlabel.h>
#endif

#ifndef QLineEdit
#include <qlineedit.h>
#endif

#ifndef QPushButton
#include <qpushbt.h>
#endif

#ifndef QPopupMenu
#include <qpopupmenu.h>
#endif

#ifndef QString
#include <qstring.h>
#endif

#ifndef vector
#include <vector> 
#endif

#ifndef KCombo 
#include <kcombo.h>
#endif

#ifndef KKeyButton 
#include <kkeydialog.h>
#endif

#ifndef vector
#include <vector>
#endif

#ifndef ESPMsgHdr
#include <EPacket.h>
#endif

#ifndef MsgHandlerQt
#include <MsgHandlerQt.h>
#endif

#ifndef Anlage
#include <AnlageParm.h>
#endif

#ifndef TlnInfo
#include <TlnInfo.h>
#endif

#ifndef PNumber
#include <PNumber.h>
#endif

class Dialer : public QDialog {
	
	Q_OBJECT

public:
    Dialer(MsgHandlerQt * = 0L, QWidget * = 0L, const char * = 0L, bool = true, WFlags = 0);
    ~Dialer();

	bool GetPBXInfo();

protected slots:
	void	nst_slot(int);
	void	msn_slot(int);
	

protected:
	MsgHandlerQt	*msghndl;
	Anlage			pbx1;
	char			*__regx;
	vector<BYTE>	msnref;
	vector<BYTE>	nstref;

	QFrame			*frame;
	QFrame			*frame1;
	QFrame			*frame2;
	QLabel			*nstL;
	QLabel			*msnL;
	QLabel			*numL;
	QLineEdit		*numE;
	KCombo		 	*nstB;
	KCombo		 	*msnB;
	KKeyButton		*t1;
	KKeyButton		*t2;
	KKeyButton		*t3;
	KKeyButton		*t4;
	KKeyButton		*t5;
	KKeyButton		*t6;
	KKeyButton		*t7;
	KKeyButton		*t8;
	KKeyButton		*t9;
	KKeyButton		*t0;
	KKeyButton		*th;
	KKeyButton		*ta;
	QPushButton 	*okB;
	QPushButton 	*cancelB;

private:
	void	readPrefs();
	void	writePrefs();

};
#endif __DIALER_H__
