#include <stdio.h>
#include <iostream.h>

#include <kapp.h>
#include <kconfig.h>
#include <LprD.moc>

extern KConfig *kConf;

/***************************************************************
 * Show Login-Dialog
 ***************************************************************/
LprDialog::LprDialog(QWidget* _parent=0, const char* _name=0, bool _modal=true, WFlags _f=0) 
	: QDialog(_parent, _name, _modal, _f)
{

	frame = new QFrame(this);
	nameL = new QLabel("Druckbefehl:",frame);
	nameE = new QLineEdit(frame);
	lineL = new QLabel("Zeilen/Seite:",frame);
	lineE = new QLineEdit(frame);
	okB = new QPushButton("OK", this);
	cancelB = new QPushButton("Abbrechen", this);


	frame->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	frame->setLineWidth(1);
	nameL->setAlignment(AlignLeft);
	lineL->setAlignment(AlignLeft);

	nameL->resize(80,20);
	lineL->resize(80,20);
	okB->resize(80,20);
	cancelB->resize(80,20);

	frame->move(5,5);
	frame->resize(300,150);

	nameL->move(5, 5);

	nameE->move(nameL->frameGeometry().right() + 5, 5);
	nameE->resize(frame->width() - 95, 20);

	lineL->move(5, nameE->frameGeometry().bottom() + 5);

	lineE->move(lineL->frameGeometry().right() + 5, nameE->frameGeometry().bottom() + 5);
	lineE->resize(nameE->width() ,nameE->height());

	frame->resize(300, lineE->frameGeometry().bottom() + 5);

	okB->move(frame->frameGeometry().left() + 8, frame->frameGeometry().bottom() + 8);
	
	cancelB->move(frame->frameGeometry().right() - 8 - cancelB->width(), frame->frameGeometry().bottom() + 8);

	resize(frame->width() + 10, cancelB->frameGeometry().bottom() + 8);

	okB->setDefault(true);
	QObject::connect(okB,     SIGNAL(clicked()), SLOT(accept()));
	QObject::connect(cancelB, SIGNAL(clicked()), SLOT(reject()));

	kConf = KApplication::getKApplication()->getConfig();
	kConf->setGroup(KApplication::getKApplication()->appName());
	readPrefs();
}

/***************************************************************
 * Free Space
 ***************************************************************/
LprDialog::~LprDialog()
{
	writePrefs();
}

void LprDialog::readPrefs()
{
	__name = strdup(kConf->readEntry("PRINTER", "lpr -Plp").data());
	__lines = kConf->readNumEntry("LPRLINES", 66);

	nameE->setText(__name);

	QString a;
	a.sprintf("%d",__lines);

	lineE->setText(a);
}

void LprDialog::writePrefs()
{
	if (result() == Accepted) {
		kConf->writeEntry("PRINTER", nameE->text());
		kConf->writeEntry("LPRLINES", lineE->text());
	}
}

const char *LprDialog::LprName() const
{
	return(nameE->text());
}

int LprDialog::LprLines() const
{
	QString a(lineE->text());

	return(a.toInt());
}
