#include <Search.moc>

extern KConfig *kConf;

/***************************************************************
 * Show Login-Dialog
 ***************************************************************/
SearchDialog::SearchDialog(QWidget* _parent=0, const char* _name=0, bool _modal=true, WFlags _f=0) 
	: QDialog(_parent, _name, _modal, _f)
{

	frame = new QFrame(this);
	regxL = new QLabel("Suche (glob):",frame);
	regxE = new QLineEdit(frame);
	okB = new QPushButton("OK", this);
	cancelB = new QPushButton("Abbrechen", this);

	frame->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	frame->setLineWidth(1);
	regxL->setAlignment(AlignLeft);

	regxL->resize(90,20);
	okB->resize(80,20);
	cancelB->resize(80,20);

	frame->move(5,5);
	frame->resize(300,150);

	regxL->move(5, 8);

	regxE->move(regxL->frameGeometry().right() + 5, 5);
	regxE->resize(frame->width() - 105, 20);

	frame->resize(300, regxE->frameGeometry().bottom() + 5);

	okB->move(frame->frameGeometry().left() + 8, frame->frameGeometry().bottom() + 8);
	
	cancelB->move(frame->frameGeometry().right() - 8 - cancelB->width(), frame->frameGeometry().bottom() + 8);

	resize(frame->width() + 10, cancelB->frameGeometry().bottom() + 8);

	okB->setDefault(true);
	QObject::connect(okB,     SIGNAL(clicked()), SLOT(accept()));
	QObject::connect(cancelB, SIGNAL(clicked()), SLOT(reject()));

	kConf = KApplication::getKApplication()->getConfig();
	kConf->setGroup(KApplication::getKApplication()->appName());
	readPrefs();


}

/***************************************************************
 * Free Space
 ***************************************************************/
SearchDialog::~SearchDialog()
{
	writePrefs();
}

void SearchDialog::readPrefs()
{
	__regx = strdup(kConf->readEntry("REGEX", "[a-zA-Z]*").data());
	regxE->setText(__regx);
}

void SearchDialog::writePrefs()
{
	if (result() == Accepted) {
		kConf->writeEntry("REGEX", regxE->text());
	}
}

const char *SearchDialog::RegEx() const
{
	return(regxE->text());
}

