/********************************************************************
 * Search.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: Search.h,v 1.1 1999/12/30 20:56:45 root Exp root $
 *
 ********************************************************************/

#ifndef __REGEXD_H__
#define __REGEXD_H__

#ifndef KApplication
#include <kapp.h>
#endif
#ifndef KConfig
#include <kconfig.h>
#endif
#ifndef QDialog
#include <qdialog.h>
#endif
#ifndef QFrame
#include <qframe.h>
#endif
#ifndef QLabel
#include <qlabel.h>
#endif
#ifndef QLineEdit
#include <qlineedit.h>
#endif
#ifndef QPushButton
#include <qpushbt.h>
#endif
#ifndef QString
#include <qstring.h>
#endif

class SearchDialog : public QDialog {
	
	Q_OBJECT

public:
    SearchDialog(QWidget *_parent=0L, const char *_name=0L, bool _modal=true, WFlags _f=0);
    ~SearchDialog();

	const char *RegEx() const;

protected:
	QFrame		*frame;
	QLabel		*regxL;
	QLineEdit	*regxE;
	QPushButton *okB;
	QPushButton *cancelB;
	char		*__regx;

private:
	void	readPrefs();
	void	writePrefs();

};
#endif __REGEXD_H__
