/********************************************************************
 * Sarah/AFrame.cpp
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: AFrame.cpp,v 1.5 1999/12/30 20:58:25 root Exp root $
 *
 ********************************************************************/

#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <iostream>
#include <vector> 
#include <qobject.h>
#include <kapp.h>
#include <ksock.h>
#include <qlabel.h>
#include <qframe.h>
#include <qmsgbox.h>
#include <qstring.h>
#include <qpushbt.h>
#include <qlistbox.h>

#include <config.h>
#include <AnlageParm.h>
#include <TlnInfo.h>
#include <EPacket.h>
#include <MsgHandlerQt.h>
#include <Login.h>
#include <AFrame.moc>

AFrame::AFrame(QWidget *_parent=0L, const char *name=0L)
	: QFrame(_parent, name)
{
	Login login(this,"Login");

	if (!login.exec()) exit(1);

	QFont f("Courier", 12);

	info=0x80;
	line=0;

	head = new QLabel("",this);
	head->resize(600,16);
	head->setAlignment(AlignLeft);
	head->setFont(f);
	head->move(5,0);

	f1 = new QFrame(this);
	f1->setFrameStyle(Panel | Sunken);
	f1->setLineWidth(1);
	f1->resize(head->width(),100);
	f1->move(0,head->frameGeometry().bottom());

	list = new QListBox(f1);
	list->resize(f1->width(),f1->height());
	list->setFont(f);

	b0 = new QPushButton("Info1", this);
	b0->resize(50,20);
	b0->move(5 ,f1->frameGeometry().bottom() + 5);

	b1 = new QPushButton("Info2", this);
	b1->resize(50,20);
	b1->move(b0->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	b2 = new QPushButton("Info3", this);
	b2->resize(50,20);
	b2->move(b1->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	b3 = new QPushButton("Info4", this);
	b3->resize(50,20);
	b3->move(b2->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	b4 = new QPushButton("Info5", this);
	b4->resize(50,20);
	b4->move(b3->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	b5 = new QPushButton("Info6", this);
	b5->resize(50,20);
	b5->move(b4->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	b6 = new QPushButton("Info7", this);
	b6->resize(50,20);
	b6->move(b5->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	b7 = new QPushButton("Info8", this);
	b7->resize(50,20);
	b7->move(b6->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	k = new QPushButton("Kill", this);
	k->resize(80,20);
	k->move(b7->frameGeometry().right() + 30 ,f1->frameGeometry().bottom() + 5);
	k->setEnabled(false);

	q = new QPushButton("Beenden", this);
	q->resize(80,20);
	q->move(k->frameGeometry().right() + 5 ,f1->frameGeometry().bottom() + 5);

	resize(q->frameGeometry().right() + 5, q->frameGeometry().bottom() + 5);
	setMinimumWidth(width());
	setMinimumHeight(height());


	QString l_appl(qApp->argv()[0]);

	mh = new MsgHandlerQt(
						login.Host(),
						login.Port(),
						&l_appl.data()[l_appl.findRev('/') + 1],
						login.User(),
						login.Pass(),
						MsgHandler::AUTH_CLEARTXT,
						MsgHandler::PERM_SCTRL
						);

	QObject::connect(mh, SIGNAL( failMsg(MsgHandlerQt*) ), SLOT( failure(MsgHandlerQt*)));

	QObject::connect(list, SIGNAL(highlighted(const char *)), SLOT(itemSelect(const char *)));
	QObject::connect(k, SIGNAL(clicked()), SLOT(sendKill()));
	QObject::connect(b0, SIGNAL(clicked()), SLOT(getInfo0()));
	QObject::connect(b1, SIGNAL(clicked()), SLOT(getInfo1()));
	QObject::connect(b2, SIGNAL(clicked()), SLOT(getInfo2()));
	QObject::connect(b3, SIGNAL(clicked()), SLOT(getInfo3()));
	QObject::connect(b4, SIGNAL(clicked()), SLOT(getInfo4()));
	QObject::connect(b5, SIGNAL(clicked()), SLOT(getInfo5()));
	QObject::connect(b6, SIGNAL(clicked()), SLOT(getInfo6()));
	QObject::connect(b7, SIGNAL(clicked()), SLOT(getInfo7()));
	QObject::connect(q, SIGNAL(clicked()), qApp, SLOT(quit()));
	QObject::connect(mh, SIGNAL( rdyMsg(ESPMsgHdr *) ), SLOT( start(ESPMsgHdr *)));
	
	mh->switchDebug(false);
	mh->esp_conn_req();

	show();

}

AFrame::~AFrame()
{
}

void AFrame::resizeEvent(QResizeEvent *)
{
	head->resize(width(), head->height());
	f1->resize(width(),height() - head->height() - q->height() - 10);
	list->resize(f1->width(), f1->height());
	b0->move(0,f1->frameGeometry().bottom() + 5);
	b1->move(b0->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);
	b2->move(b1->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);
	b3->move(b2->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);
	b4->move(b3->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);
	b5->move(b4->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);
	b6->move(b5->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);
	b7->move(b6->frameGeometry().right() + 5, f1->frameGeometry().bottom() + 5);

	q->move(width() - q->width() - 5, f1->frameGeometry().bottom() + 5);
	k->move(q->frameGeometry().left() - 5 - k->width(), f1->frameGeometry().bottom() + 5);
}

void AFrame::itemSelect(const char *s)
{
	sscanf(s,"%i",&linkid);

	k->setEnabled(linkid != 0);

	if (!linkid) return;
}

void AFrame::sendKill()
{
	vector<BYTE> data(2);

	if (!linkid) return;

	data[0]=(unsigned char)((linkid >> 8) & 0x00FF);
	data[1]=(unsigned char)(linkid & 0x00FF);
	mh->asyncSend(MsgHandler::G_ESP, MsgHandler::ESP_SRVR_KILL, data);
}

void AFrame::getInfo()
{
	vector<BYTE> data(2);

	line = 0;

	list->clear();

	data[0]=line;
	data[1]=info;
	mh->asyncSend(MsgHandler::G_ESP, MsgHandler::ESP_SRVR_STAT, data);
}

void AFrame::getInfo0()
{
	info = 0;
	getInfo();
}

void AFrame::getInfo1()
{
	info = 1;
	getInfo();
}

void AFrame::getInfo2()
{
	info = 2;
	getInfo();
}

void AFrame::getInfo3()
{
	info = 4;
	getInfo();
}

void AFrame::getInfo4()
{
	info = 8;
	getInfo();
}

void AFrame::getInfo5()
{
	info = 16;
	getInfo();
}

void AFrame::getInfo6()
{
	info = 32;
	getInfo();
}

void AFrame::getInfo7()
{
	info = 64;
	getInfo();
}

void AFrame::start(ESPMsgHdr *esp)
{
	vector<BYTE> data(2);

	QObject::connect(mh, SIGNAL( espMsg(ESPMsgHdr *) ), SLOT( handleESP(ESPMsgHdr *)));
	
	data[0]=line;
	data[1]=info;
	mh->asyncSend(MsgHandler::G_ESP, MsgHandler::ESP_SRVR_STAT, data );
}

void AFrame::handleESP(ESPMsgHdr *esp)
{
	vector<BYTE> data(128);

	switch (esp->element) {
		case MsgHandler::ESP_SRVR_STAT :
			if (info != 0x80 && !line) {
				head->setText((const char *)esp->data.begin());
			} else if (info != 0x80) {
				if (esp->data[0]!=0)
					list->insertItem((const char *)esp->data.begin());
			} else {
				if (esp->data[0] != '\0') switch (line) {
					case 0x00: b0->setText((const char *)esp->data.begin()); break;
					case 0x01: b1->setText((const char *)esp->data.begin()); break;
					case 0x02: b2->setText((const char *)esp->data.begin()); break;
					case 0x03: b3->setText((const char *)esp->data.begin()); break;
					case 0x04: b4->setText((const char *)esp->data.begin()); break;
					case 0x05: b5->setText((const char *)esp->data.begin()); break;
					case 0x06: b6->setText((const char *)esp->data.begin()); break;
					case 0x07: b7->setText((const char *)esp->data.begin()); break;
					default:
						break;
				} else switch (line) {
					case 0x00: b0->setEnabled(false);; break;
					case 0x01: b1->setEnabled(false);; break;
					case 0x02: b2->setEnabled(false);; break;
					case 0x03: b3->setEnabled(false);; break;
					case 0x04: b4->setEnabled(false);; break;
					case 0x05: b5->setEnabled(false);; break;
					case 0x06: b6->setEnabled(false);; break;
					case 0x07: b7->setEnabled(false);; break;
					default:
						break;
				}
			}
			if (esp->data.size() > 1 || (info == 0x80 && line < 8)) {
				line++;
				data[0]=line;
				data[1]=info;
				mh->asyncSend(MsgHandler::G_ESP, MsgHandler::ESP_SRVR_STAT, data);
			} else {
				line=0;
				if (info == 0x80) {
					info = 0;
					getInfo();
				}
			}
			break;
		case MsgHandler::ESP_SRVR_KILL :
		case MsgHandler::ESP_SRVR_WAKE :
			getInfo();
			break;
		default :
			break;
	}
}


void AFrame::failure(MsgHandlerQt*)
{
	QString l_appl(qApp->argv()[0]);

	if (mh->failFatal())
		QMessageBox::critical( 0, l_appl.right(l_appl.length() - l_appl.findRev('/') - 1), QString(mh->failReason()));
	else
		QMessageBox::information( 0, l_appl.right(l_appl.length() - l_appl.findRev('/') - 1), QString(mh->failReason()));
}

