/********************************************************************
 * level2common.c
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: level2common.c,v 1.3 1999/12/30 21:00:15 root Exp root $
 *
 ********************************************************************/
#include <stdio.h>
#include <sys/time.h>

#include <glob.h>
#include <cl_utils.h>
#include <level2pbx.h>

extern FILE	*logfp;
extern int	quit;

/********************************************************************
 *
 ********************************************************************/
int common_wait_io(fd_set *fds, int fdrange)
{
	struct timeval  timeout;

	timeout.tv_sec = 0;
	timeout.tv_usec = 50;

	return(select(fdrange,fds,NULL,NULL,&timeout));
}

/********************************************************************
 *
 ********************************************************************/
int common_mainloop()
{
	fd_set	fds;
	int		fdrange;
	int		data_wait;

	while (!quit) {

		fdrange = Cl_highfd();
		FD_ZERO(&fds);
		Cl_fdset_all(&fds);

		data_wait = common_wait_io(&fds, fdrange);

		if (data_wait > 0)
			Cl_handle_data(&fds);
		else if (data_wait < 0)
			return(data_wait);
		else
			Cl_idle();

	}
	return(quit);
}
