/********************************************************************
 * level2pbx.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: level2pbx.h,v 1.2 1999/03/07 20:02:04 root Exp $
 *
 ********************************************************************/
#ifndef __LEVEL2PBX_H__
#define __LEVEL2PBX_H__

/* Sendeversuchsanzahl bei Checksummen-Fehlern */
#define BC_RETRIES		5

/* Ackermannsche E-Befehle */
#define CTI_ESC			(BYTE)0xE0
#define CTI_NUL			(BYTE)0xE1
#define CTI_SEND_REQ    (BYTE)0xE2
#define CTI_REC_READY   (BYTE)0xE3
#define CTI_BC_ACK		(BYTE)0xE4
#define CTI_BC_ERR		(BYTE)0xE5
#define CTI_RST_REQ		(BYTE)0xE6
#define CTI_RST_ACK		(BYTE)0xE7
#define CTI_END_DATA	(BYTE)0xE8
#define CTI_START_DATA	(BYTE)0xAA

typedef struct packEntry PackEntry;

struct packEntry {
	struct packEntry*	next;
	BYTE*				pack;
	int					len;
	int					stat;
};

/* Serial Port Handling */
cl_mgmt *	pbx_init_proc();
void		pbx_close();
int			pbx_fd();

/* Data Handling */
int		pbx_send(cl_mgmt *cl, BYTE *pak,int len);
BYTE *	pbx_receive(cl_mgmt *cl, int *len);

#endif __LEVEL2PBX_H__
