/********************************************************************
 * level3.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: level3.h,v 1.3 1999/12/30 21:00:15 root Exp root $
 *
 ********************************************************************/
#ifndef __LEVEL3_H__
#define __LEVEL3_H__
 
#define K_CTI_GS_MASK   0x01
#define K_CTI_GET       0x00
#define K_CTI_SET       0x01
#define K_CTI_AD_MASK   0x02
#define K_CTI_ADD       0x00
#define K_CTI_DEL       0x02
#define K_CTI_OE_MASK   0x04
#define K_CTI_OK        0x00
#define K_CTI_ERR       0x04
#define K_CTI_CR_MASK   0x08
#define K_CTI_CMD       0x00
#define K_CTI_RSP       0x08

#define S_CTI_RSP(x)    ((x & K_CTI_CR_MASK) == K_CTI_RSP)
#define S_CTI_ERR(x)    ((x & K_CTI_OE_MASK) == K_CTI_ERR)
#define S_CTI_DEL(x)    ((x & K_CTI_AD_MASK) == K_CTI_DEL)
#define S_CTI_SET(x)    ((x & K_CTI_GS_MASK) == K_CTI_SET)

#define CTI_TYP(x)		(x & K_CTI_TYP_MASK)
#define CTI_GRP(x)		((x & K_CTI_TYP_MASK) >> 4)
#define CTI_FLG(x)		(x & K_CTI_FLG_MASK)

typedef struct anlmsghdr {
    unsigned char	paketnummer;
    unsigned char	anlage;
    unsigned char	linkid_Hi;
    unsigned char	linkid_Lo;
    unsigned char	gruppe;
    unsigned char	element;
    unsigned char	length;
    unsigned char	data[1];
} ANLMsgHdr;


typedef struct espmsghdr {
    unsigned char	folgenummer;
    unsigned char	anlage;
    unsigned char	gruppe;
    unsigned char	element;
    unsigned char	length;
    unsigned char	data[1];
} ESPMsgHdr;

void	l3_verfylink_get();
void	l3_linkid_req(cl_mgmt *src);
void	l3_handle_cl_data(cl_mgmt *cl);
int	l3_handle_pbx_data(cl_mgmt *cl);
void	l3_query_login(cl_mgmt *cl);
void	l3_send_EspMsg(cl_mgmt *src, cl_mgmt *dst, ESPMsgHdr *msg);
void	l3_send(cl_mgmt *cl, void *data, size_t len);
BYTE	l3_inc_server_pnum();

#endif __LEVEL3_H__
