/********************************************************************
 * lib/konfig.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: konfig.h,v 1.1 1999/12/30 21:04:17 root Exp root $
 *
 ********************************************************************/

#ifndef __KONFIG_H__
#define __KONFIG_H__

typedef struct anl_vers_struct {
	BYTE	IntRelease[4];
	char	Version[16];
	char	AnlTyp[4];
	char	Land[5];
	char	Oem[11];
	BYTE	Update;
	BYTE	FlashHw;
	BYTE	Reserve[22];
} anl_vers_type;

typedef struct anl_betriebs_struct {
	BYTE	BetriebsArt;
	BYTE	Language;
	BYTE	Waehrung[9];
} anl_betriebs_type;

typedef struct anl_date_struct {
	BYTE	Year;
	BYTE	Month;
	BYTE	Day;
	BYTE	Hour;
	BYTE	Minute;
} anl_date_type;

typedef struct anl_maxparam_struct {
	BYTE	Anz_ab;
	BYTE	Anz_Tfe;
	BYTE	Anz_S0;
	BYTE	Anz_S0ext;
	BYTE	Anz_S0int;
	BYTE	Anz_S0quer;
	BYTE	Anz_Bytes;
} anl_maxparam_type;

typedef struct anl_fernwirken_struct {
	BYTE	Status;
} anl_fernwirken_type;

typedef struct anl_mastrslav_struct {
	BYTE	AnlNr;
} anl_mastrslav_type;

typedef struct anl_tlninfo_struct {
	WORD	BitPosition;
	BYTE	Typ;
	BYTE	Untertyp;
	BYTE	TlnRnr[2];
} anl_tlninfo_type;

typedef struct konfig_struct {
	anl_vers_type		Version;
	anl_betriebs_type	Betriebsart;
	anl_maxparam_type	MaxParam;
	anl_fernwirken_type	Fernwirken;
	anl_mastrslav_type	MasterSlave;
	anl_tlninfo_type	TlnInfo[51];
} konfig_type;

typedef struct L7_GebSummBetragStruct {
	LONG	last_cost;
	WORD	last_duration;
	LONG	sum;
	BYTE	xxx;
} GSBType;

#endif  __KONFIG_H__
