/********************************************************************
 * lib/server_conn.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: server_conn.h,v 1.1 1999/12/30 21:04:17 root Exp root $
 *
 ********************************************************************/
 
#ifndef	__SERVCONN_H__
#define __SERVCONN_H__

#define HANDLED		1
#define NOT_HANDLED	0

typedef int (*HPRC)(int fd, EspMsg *esp);

extern HPRC std_Procs[16];
extern HPRC user_Procs[16];

int 	set_user(char *user);	/* returns 0 if empty , 1 if set*/
int 	set_passwd(char *pw);	/* returns 0 if empty , 1 if set*/
char *	get_user();
char *	get_passwd();
int		read_maKsrc(char **user, char **pw, char **host, int *port);
								/* returns 0 if not readable */

void	InitProcs(int debug, FILE *logfp);
void	SetStdProc(BYTE which, void *proc);
void	SetUsrProc(BYTE which, void *proc);
void	SetStartProc(void *proc);

int		Server_Connect(char *machine, int port);

void	send_server(int fd, BYTE a, BYTE g, BYTE e, BYTE l, BYTE *d);

EspMsg	*conn_request(int fd, BYTE perm, BYTE auth, char *appname, int async);
EspMsg	*conn_auth_cleartext(int fd, char *user, char *passw, int async);
EspMsg  *send_request(int fd, BYTE a, BYTE g, BYTE e, BYTE l, BYTE *d);

BYTE	inc_folgenr();

int		PacketWaitAsync(int sock);
EspMsg	*PacketWaitSync(int sock);

#endif	__SERVCONN_H__
