/* ******************************************************************
 * AnlageParm.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: AnlageParm.h,v 1.5 2000/01/08 10:18:27 root Exp root $
 *
 * ******************************************************************/

#ifndef ANLPARM_H_
#define ANLPARM_H_

#ifndef BYTE
#define BYTE unsigned char
#endif

#include <vector>
#include <string>

class Anlage {
public:

typedef struct AnlSwVersStruct {
		BYTE Rel1;
		BYTE Rel2;
		BYTE Rel3;
		BYTE Rel4;
		char Version[16];
		char AnlTyp[4];
		char Land[5];
		char Oem[11];
		BYTE Update;
		BYTE FlashHw;
		BYTE Reserve[22];
} AnlSwVersType;

	Anlage();
	~Anlage();

	void	setTyp(const vector<BYTE>&);
	void	setMaxParm(const vector<BYTE>&);
	void	setBArt(BYTE);
	void	setSWVers(const vector<BYTE>&);
	
	char*	        Vers() const;
	int		Typ() const;
	int		S0Sum() const;
	int		S0Int() const;
	int		S0Ext() const;
	int		EvtBytes() const;

	friend	ostream& operator<< ( ostream& strm , const Anlage& anlg);
protected:
	int				n_type;
	unsigned char	n_bart;
	unsigned char	n_nab;
	unsigned char	n_ntfe;
	unsigned char	n_s0;
	unsigned char	n_s0ext;
	unsigned char	n_s0int;
	unsigned char	n_s0quer;
	unsigned char	n_bytes;
	unsigned char	n_ferns;
	string		s_type;
	AnlSwVersType	s_vers;
};
#endif ANLPARM_H_



