/* ******************************************************************
 * Login.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: Login.h,v 1.3 2000/01/08 10:18:27 root Exp root $
 *
 * ******************************************************************/

#ifndef LOGIN_H_
#define LOGIN_H_

#include <qdialog.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbt.h>

class Login : public QDialog {
	
	Q_OBJECT

public:
    Login(QWidget *_parent=0L, const char *_name=0L, bool _modal=true, WFlags _f=0);
    ~Login();

	const char *User() const;
	const char *Host() const;
	const char *Pass() const;
	int   Port() const;

protected:
	QFrame		*frame;
	QLabel		*nameL;
	QLineEdit	*nameE;
	QLabel		*passL;
	QLineEdit	*passE;
	QLabel		*hostL;
	QLineEdit	*hostE;
	QLabel		*portL;
	QLineEdit	*portE;
	QPushButton *okB;
	QPushButton *cancelB;
	int			__port;
	char		*__name;
	char		*__pass;
	char		*__host;

private:
	void	readPrefs();
	void	writePrefs();

};
#endif LOGIN_H_
