/* ******************************************************************
 * MsgHandlerNG.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: MsgHandlerNG.h,v 1.2 2000/01/08 10:18:27 root Exp $
 *
 * ******************************************************************/

#ifndef MSGHANDLERNG_H_
#define MSGHANDLERNG_H_

#include <NGSocket.h>
#include "EPacket.h"
#include "MsgHandler.h"

class MsgHandlerNG : public Object , public MsgHandler {

public:
	// Contructors & Destructors
	MsgHandlerNG(const char *, const int, const char *, const char *, const char *, const BYTE, const BYTE);
	~MsgHandlerNG(){delete conn;};

	// Packet Handler
	void msg_Emitter(ESPMsgHdr *);
	
	int socket(){return conn->socket();};
	void processEvents();

// slots:
	void slotHandle(NGSocket*);
	void slotClose(NGSocket*);

// signals:

	Signal1<void,ESPMsgHdr*> espMsg;		// void espMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> anlMsg;		// void anlMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> porMsg;		// void porMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> gebMsg;		// void gebMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> orgMsg;		// void orgMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> tlnMsg;		// void tlnMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> auxMsg;		// void auxMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> staMsg;		// void staMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> offMsg;		// void offMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> vbgMsg;		// void vbgMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> evtMsg;		// void evtMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> tstMsg;		// void tstMsg(ESPMsgHdr *);
	Signal1<void,ESPMsgHdr*> fabMsg;		// void fabMsg(ESPMsgHdr *);

	Signal1<void,ESPMsgHdr*> rdyMsg;		// void rdyMsg(ESPMsgHdr *);

	Signal1<void,MsgHandler*> failMsg;					// void failMsg(MsgHandlerNG*);

protected:
	NGSocket* conn;

	void sendfailMsg(char *msg, int fatal);
	void sendrdyMsg(ESPMsgHdr* ep){ rdyMsg.emit(ep);};

};

#endif MSGHANDLERNG_H_

