/* ******************************************************************
 * Q931.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id$
 *
 * ******************************************************************/

#ifndef Q931_H_
#define Q931_H_
#include <string>
#include <strstream>
#include <EPacket.h>

#define GROUP_TEI		0x7F
#define CTRL_SAPI		0x00
#define PROT_ACKERMANN	0xAA
#define PROT_EURO		0x08

#define	DIR_NET2USER	1
#define	DIR_USER2NET	2

#define	AKM_LINESTAT	1
#define	AKM_DATETIME	2

class q931Pack {
	public:
		q931Pack(ESPMsgHdr *ep, int d)	{ debug = d; analyze(ep); }
		~q931Pack()	{ }

		BYTE		dir;
		BYTE		protocol;
		BYTE		msgtype;
		string		Caller;
		string		Called;
		string		DateTime;

	private:
		int	debug;
		BYTE		ack_empty;

		const char* getMsgTyp(int);
		const char* getIETyp(int);
		void prDateTime(ESPMsgHdr *, size_t, ostrstream&);
		void prLocation(ESPMsgHdr *, size_t, ostrstream&);
		void prUser2User(ESPMsgHdr *, size_t, ostrstream&);
		void prCalled(ESPMsgHdr *, size_t, ostrstream&);
		void prCalling(ESPMsgHdr *, size_t, ostrstream&);
		void head(ESPMsgHdr *, ostrstream&);
		void analyzEuro(ESPMsgHdr *, size_t, ostrstream&);
		void analyzAckermann(ESPMsgHdr *, size_t, ostrstream&);
		void analyze(ESPMsgHdr *);

};

#endif Q931_H_
