/* ******************************************************************
 * TlnInfo.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: TlnInfo.h,v 1.5 2000/01/08 10:18:27 root Exp root $
 *
 * ******************************************************************/

#ifndef TLNINFO_H_
#define TLNINFO_H_

#ifndef ostream
#include <iostream>
#endif

#ifndef BYTE
#define BYTE unsigned char
#endif

class TlnInfo {
public:
	TlnInfo(const char*);
	~TlnInfo();

	int		BitPos() const;
	int		Typ() const;
	int		Untertyp() const;
	int		Num() const;
	char *	Nummer() const;

	const char *GetTypName(unsigned int) const;
	const char *GetUTypName(unsigned int) const;

	friend ostream& operator<< ( ostream&, const TlnInfo&);

	typedef enum {
		S0Amt = 0,
		S0Intern,
		S0Quer,
		Analog,
		TFE,
		UndefinedTyp = 0xFF
	};

	typedef enum {
		Telefon = 0,
		Fax,
		AB,
		Modem,
		Multi,
		S0Karte,
		UndefinedSubTyp = 0xFF
	};
	

protected:
	unsigned char   b1;
	unsigned char   b2;
	unsigned char   typ;
	unsigned char   utyp;
	unsigned char   num;
	unsigned char   ff;
	int				led_index;

};
#endif TLNINFO_H_
