/********************************************************************
 * lib/Decode.c
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: Decode.c,v 1.3 1999/12/30 21:00:56 root Exp root $
 *
 ********************************************************************/
 
#include <string.h>

/********************************************************************
 * Decodes Phonenumbers ending with 0x?F
 * returns pointer to Number-String
 ********************************************************************/
char *get_Phonenumber(char *buf)
{
	static char ret[25];
	char *p;
	int i;
	unsigned char a,b;

	p=ret;

	if (buf[0]==-1)   return("----------");
	for (i=0;i<12;i++)  {
		a=(buf[i] >> 4) & 0x0F;
		b=buf[i] & 0x0F;
		if (a==0x0E && b==0x07) return("<-------->");
		if (a==0x0B && b==0x0B) return("#9");
		if (a == 0x0F) {
			p[0]='\0';
			return(ret);
		}
		p[0]=(char)(a+48);
		p++;
		if (b == 0x0F) {
			p[0]='\0';
			return(ret);
		}
		p[0]=(char)(b+48);
		p++;
	}
	p[0]='\0';
	return(ret);
}

/********************************************************************
 * Encodes Phonenumbers
 * returns pointer to Number-String ending with 0x?F
 ********************************************************************/
char *set_Phonenumber(char *buf, int *len)
{
	static char ret[25];
	char *p;
	int i = 0;
	unsigned char a,b;

	p=ret;

	memset(ret,0,25);

	while ( 1 ) {
		a = buf[i++];
		if (!a) {
			*p++= 0xFF;
			break;
		}

		b = buf[i++];
		if (!b) {
			b = 0x0F;
			*p++=(((a - '0') << 4) | b);
			break;
		}

		*p++=(((a - '0') << 4) | (b - '0'));
	}

	*len = ( p - ret );

	return(ret);
}

